function Create(self)
	self.delayTimer = Timer();
	self.actionPhase = 0;
end

function Update(self)
	for actor in MovableMan.Actors do
		if actor.ClassName ~= "ADoor" and (actor.Pos.X >= self.Pos.X - 30) and (actor.Pos.X <= self.Pos.X + 30) and (actor.Pos.Y >= self.Pos.Y - 30) and (actor.Pos.Y <= self.Pos.Y + 15) then
			self.actionPhase = 1;
			self.delayTimer:Reset();
		end
	end
	
	if self.actionPhase == 1 then
		local soundfx = CreateAEmitter("Frag Mine Sound Detonate");
		soundfx.Pos = self.Pos;
		MovableMan:AddParticle(soundfx);
	end

	if self.delayTimer:IsPastSimMS(500) and self.actionPhase == 1 then
		self:GibThis();
	end
end