function Create(self)
	self.origSharpLength = ToHDFirearm(self).SharpLength;
	self.origShakeRange = ToHDFirearm(self).ShakeRange;
	
	self.reloadTimer = Timer();
	self.loadedShell = false;
	self.reloadCycle = false;

	self.reloadDelay = 200;
	
	self.ejectedShell = false;

	if self.Magazine then
		self.ammoCounter = self.Magazine.RoundCount;
	else
		self.ammoCounter = 0;
	end
end

function Update(self)
	Unit = MovableMan:GetMOFromID(self.RootID);
	if self:IsAttached() and Unit:IsInGroup("Gunslinger") == true then
		self.SharpLength = self.origSharpLength*2;
		self.ShakeRange = self.origShakeRange*2;
		self.GetsHitByMOs = false;
	else
		self.SharpLength = self.origSharpLength;
		self.ShakeRange = self.origShakeRange;
		self.GetsHitByMOs = true;
	end

	if self.Magazine ~= nil then
		if self.loadedShell == false then
			self.ammoCounter = self.Magazine.RoundCount;
		else
			self.loadedShell = false;
			self.Magazine.RoundCount = self.ammoCounter + 1;
		end
	else
		self.reloadTimer:Reset();
		self.reloadCycle = true;
		self.loadedShell = true;
	end

	if self:IsActivated() then
		self.reloadCycle = false;
	end

	if self.reloadCycle == true and self.reloadTimer:IsPastSimMS(self.reloadDelay) and self:IsFull() == false then
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			ToActor(actor):GetController():SetState(Controller.WEAPON_RELOAD,true);
		end
		self.reloadCycle = false;
	end
	
	if self.Magazine ~= nil then
		self.ejectedShell = false;
	else
		if self.ejectedShell == false then
			self.ejectedShell = true;
			if self.HFlipped == false then
				self.negativeNum = 1;
			else
				self.negativeNum = -1;
			end
			for i = 1, 2, 3 do
				local shell = CreateMOSParticle("Casing");
				shell.Pos = self.Pos;
				shell.Vel = Vector(-2*self.negativeNum,-1):RadRotate(self.RotAngle):DegRotate((math.random()*16)-8);
				MovableMan:AddParticle(shell);
			end
		end
	end
end