function Create(self)
	self.gibdist = 25;
	self.delayTimer = Timer();
	self.actionPhase = 0;
end

function Update(self)
	local rand = math.random();
	if rand <= .02 then
		for actor in MovableMan.Actors do
			local curdist;
			curdist = math.sqrt(math.pow(self.Pos.X - actor.Pos.X,2) + math.pow(self.Pos.Y - actor.Pos.Y,2))
			if curdist <= self.gibdist and actor.Team ~= self.Team then
				if actor.ClassName ~= "Actor" and actor.ClassName ~= "AHuman" and actor.ClassName ~= "ACrab" then
					self.actionPhase = 1;
					self.delayTimer:Reset();
				else
					self.actionPhase = 1;
					self.delayTimer:Reset();
				end
			end
		end
	end
	
	if self.actionPhase == 1 then
		local soundfx = CreateAEmitter("Tripwire Sound");
		soundfx.Pos = self.Pos;
		MovableMan:AddParticle(soundfx);
	end

	if self.delayTimer:IsPastSimMS(750) and self.actionPhase == 1 then
		self:GibThis();
	end
end